#ifndef TRANSACTIONSTATUS_H
#define TRANSACTIONSTATUS_H

#define TransactionStatus_StatusAborted 1
#define TransactionStatus_StatusPending 2
#define TransactionStatus_StatusCommitted 3
#define TransactionStatus_StatusRetrying 4
#define TransactionStatus_StatusSentPartial 5
#define TransactionStatus_StatusSentFully 6
#define TransactionStatus_StatusNoEffect 10

class TransactionStatus {
private:
	char status;
	bool applicationReleased;
	int64_t transactionSequenceNumber;
	int64_t arbitrator;

public:
	TransactionStatus(char _status, int64_t _arbitrator) :
		status(_status),
		applicationReleased(false),
		transactionSequenceNumber(0),
		arbitrator(_arbitrator) {
	}

	char getStatus() { return status; }
	void setStatus(char _status) { status = _status; }
	int64_t getTransactionSequenceNumber() { return transactionSequenceNumber; }
	void setTransactionSequenceNumber(int64_t _transactionSequenceNumber) { transactionSequenceNumber = _transactionSequenceNumber; }
	int64_t getTransactionArbitrator() { return arbitrator; }
	void release() { applicationReleased = true;}
	bool getReleased() { return applicationReleased;}
};
#endif
